/*
  Сервис интеграции ПП Парус 8 с WEB API
  Точка входа в сервер приложений
*/

//----------------------
// Подключение библиотек
//----------------------

require("module-alias/register"); //Поддержка псевонимов при подключении модулей
const cfg = require("./config.js"); //Настройки сервера приложений
const app = require("./core/app.js"); //Сервер приложений

//--------------------------
// Глобальные идентификаторы
//--------------------------

let appSrv = new app.ParusAppServer(cfg); //Экземпляр сервера приложений

//----------------------------------------
// Управление процессом сервера приложений
//----------------------------------------

//Обработка события "выход" жизненного цикла процесса
process.on("exit", code => {
    //Сообщим о завершении процесса
    appSrv.logger.warn("Сервер приложений остановлен (код: " + code + ") ");
});

//Перехват CTRL + C (останова процесса)
process.on("SIGINT", () => {
    //Инициируем выход из процесса
    appSrv.stop();
});

//------------
// Точка входа
//------------

//Старутем
appSrv
    .run()
    .then(r => {})
    .catch(e => {
        appSrv.logger.error("НЕОЖИДАННАЯ ОШИБКА: " + e);
    });
